/**
 * Author: Dave Toth
 * Date: Fall 2005
 */

import java.net.*;      // Use sockets.
import java.io.*;       // Read and write over sockets.
import java.util.*;     // Timers, Vectors, Hashtable
import java.util.Timer; // Timers
import java.awt.*;      // Timers


public class CheckpointThread extends Thread {
		 
    ScienceApplication scienceApplication;
    private int counter;
    private boolean isRunning;
    
    public CheckpointThread(ScienceApplication scienceApplication) {
	this.scienceApplication = scienceApplication;
	counter = 0;
	isRunning = true;
    }
    
    public void setRunning(boolean status) {
	isRunning = status;
    }

    public void pauseThread() {
	//System.out.print("$$$ CHKPT TH: ");
	if (isRunning == true) {
	    //System.out.println("PAUSED: " + ValidatorClient.getCurrentSimulationTime());
	}
	else {
	    //System.out.println("HALTED: " + ValidatorClient.getCurrentSimulationTime());
	}
	while (isRunning == true) {
	    try {
		//System.out.print("$$$ CHKPT TH: ");
		Thread.sleep(1209600000); // Sleep for 14 days - we'll get interrupted before then
	    }
	    catch (InterruptedException ie2) {
		if (isRunning == true) {
		    if (Thread.interrupted()) {/*System.out.println("changin status");*/}
		    //System.out.println("RESUMED: " + ValidatorClient.getCurrentSimulationTime());
		    break;
		}
		else {
		    scienceApplication.timeForCheckpoint = false;
		    if (Thread.interrupted()) {/*System.out.println("changin status");*/}
		    //System.out.println("HALTED: " + ValidatorClient.getCurrentSimulationTime());
		    break;
		}
	    }
	}
	//System.out.println("------------------broken out of inner while");
    }
    
    public void run() {
	//long nowTime3 = System.currentTimeMillis();// TODO remove - debugging only
	//long delta3 = (nowTime3 - ValidatorClient.startTime)/1000; // TODO remove - debugging only
	//System.out.println("Started ckpt thread at " + delta3);// TODO remove - debugging only
	while ((isRunning == true) && (counter < 1574)) { // TODO change back to 1574
	    try {
		Thread.sleep(1000);
		counter ++;
		if (counter >= 1574) { // TODO change back to 1574
		    scienceApplication.timeForCheckpoint = true;
		}
		if (Thread.interrupted()) { // If we were interrupted but did not understand that...
		    //System.out.println("@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ - ckpt thread didn't notice interrupt");
		    pauseThread();
		}
	    }
	    catch (InterruptedException ie) {
		if (Thread.interrupted()) {} // DO NOTHING - JUST CLEAR THE FLAG
		pauseThread();
	    } // END CATCH
	}
    }
}















